var PMap = function (mapid, opts){
    this.mapid = mapid;
    this.opts = opts || {};
    for (var i in this.opts) { this[i] = this.opts[i]; }

    this.ext = function (op) {   
        for (var j in op) { this[j] = op[j]; }
    }
    //	
    this.createMap = function (mapid) {
        this.create(mapid || this.mapid);
    }
};

var BAIDU_MAP = 1;
var GOOGLE_MAP = 2;
var BING_MAP = 3;
var MAPABC_MAP = 4;
var BAIDU_MAP_PATH = './js/baidu/provider.js';
var GOOGLE_MAP_PATH = './js/google/provider.js';
var BING_MAP_PATH = './js/bing/provider.js';
var MAPABC_MAP_PATH = './js/mapabc/provider.js';
//BAIDU_MAP		1
//GOOGLE_MAP	2
function createMapProvider(mapType, mapid) {
    switch (mapType) {
        case BAIDU_MAP:
            return new BaiduProvider(mapid);
            break;
        case GOOGLE_MAP:
            return new GGProvider(mapid);
            break;
        case BING_MAP:
            return new BingProvider(mapid);
            break;
        case MAPABC_MAP:
            return new MapabcProvider(mapid);
            break;
    }
    return null;
}
