﻿//car manager object define
var carMng = {
    ary: new Array(),
    push: function (o) {
        var a = new function () {
            for (var i in o) { this[i] = o[i]; }
            this.direction = this.direction || 0;
			this.visible = true;
			this.state	= this.state ? parseInt(this.state) : 0
            this.setLabel = function (s) {
                this.title = s;
                this.name = s;  
                if (!this.label) {
                    var pt = this.pt || gc.map.getCenter();
                    this.label = gc.map.createLabel(this.title, pt, gc.map.createSize(15, 2));
                } else {
                    gc.map.updateLabel(this.label, this.pt, this.title);
                }
            }
			this.getPoint = function(){
				var pt = this.pt ||  globalCfg.map.getCenter();
				return pt;
			}
            this.setPoint = function (pt) {
                this.pt = pt;
                if (this.label) {
                    gc.map.updateLabel(this.label, pt, this.title);
                }
            }
            this.setDirection = function (d) {
                this.direction = parseInt(d);
				var lDir = this.direction;
				lDir = ((lDir + 22) / 45) & 0x07;
				this.direction = lDir;
                /*if (this.direction >= 8)
				{	this.direction = 7;}
				else if(this.direction < 0 )
				{	this.direction = 0;}
				*/
            }
            this.getIconPath = function () {
                var imgDirectory = "./image";
                var imgVehicleType = ["car", "bus", "police", "schoolbus"];
                var imgVehicleState = ["offline_long", "offline_moment",
                "offlining", "offline_unnormal", "online_alarm", "online_normal"];

                var imgCarsNormal = ["east_green.png", "northeast_green.png",
                "north_green.png", "northwest_green.png", "west_green.png",
                "southwest_green.png", "south_green.png", "southeast_green.png"];

                var imgCarsAlarm = ["east_green.gif", "northeast_green.gif",
                			"north_green.gif", "northwest_green.gif",
                						"west_green.gif", "southwest_green.gif",
                									"south_green.gif", "southeast_green.gif"];

				var s = parseInt(this.state);
                var imageFile = imgDirectory + "/" + imgVehicleType[this.type] + "/" + imgVehicleState[s] + "/";
                if (this.state == 4) {
                    imageFile = imageFile + imgCarsAlarm[this.direction];
                }
                else {
                    imageFile = imageFile + imgCarsNormal[this.direction];
                }
                return imageFile;
            }
            this.refreshIcon = function () {
                var pt = this.pt || globalCfg.map.getCenter();
                if (this.iconObj) { globalCfg.map.updateIcon(this.iconObj, this.getIconPath()); }
                else {
                    this.iconObj = globalCfg.map.createIcon(this.getIconPath(), globalCfg.map.createSize(32, 32));
                }
                if (this.maker) {
                    globalCfg.map.setMakerIcon(this.maker, this.iconObj, pt);
                }
            }
			this.setVisible = function(b)
			{
				if (this.visible == b) return;
				if(!(this.visible = b)){
					if(this.maker){ globalCfg.map.removeObj(this.maker);}
					if(this.label){ globalCfg.map.removeObj(this.label);}
					if(this.iconObj){ globalCfg.map.removeObj(this.iconObj);}
				}else{
					if(this.maker){ globalCfg.map.addObj(this.maker);}
					if(this.label){ globalCfg.map.addObj(this.label);}
					if(this.iconObj){ globalCfg.map.addObj(this.iconObj);}
				
				}
			}
        };


        this.ary.push(a);
        return a;
    },
    remove: function (id) {
        var curid = -1;
        for (var i = 0; i < this.ary.length; i++)
            if (this.ary[i].id == id) {
                curid = i;
                break;
            }

        if (curid != -1) {
            for (var i = curid; i + 1 < this.ary.length; i++) {
                this.ary[i] = this.ary[i + 1];
            }
            this.ary.pop();
        }
    },
    get: function (id) {
        for (var i = 0; i < this.ary.length; i++) {
            if (id == this.ary[i].id) return this.ary[i];
        }
    }
};

//line manager object
var lineMng_ = function(){
    this.ary =  new Array();
    this.push =  function (o) {
        var t = new function () {
            for (var i in o) { this[i] = o[i]; }
        };
        this.ary.push(t);
        return t;
    }
	this.remove = function (id) {
        var curid = -1;
        for (var i = 0; i < this.ary.length; i++)
            if (this.ary[i].id == id) {
                curid = i;
                break;
            }

        if (curid != -1) {
            for (var i = curid; i + 1 < this.ary.length; i++) {
                this.ary[i] = this.ary[i + 1];
            }
            this.ary.pop();
        }
    };
	this.get=function (id) {
        for (var i = 0; i < this.ary.length; i++) {
            if (id == this.ary[i].id) return this.ary[i];
        }
		return null;
    },
    this.geti= function (i) {
        if (i < this.ary.length) return this.ary[i];
    }
	this.size = function () {
        return this.ary.length;
    } 
    this.toString =  function () {
        var s = '{<br/>';
        for (var i in this.ary) {
            s += '[';
            for (var j in this.ary[i]) {
                s += j.toString() + ':' + this.ary[i][j] + ',';
            }
            s += '],<br/>';
        }
        s += '}';
        return s;
    }
};
 
var lineAlmMng = new lineMng_();
var lineMng = new lineMng_();
var lineOldMng = new lineMng_();

function plEncoded(obj) {
    var pt = obj.points;
    var ls = obj.levels;
    if (pt && ls) {
        function o(j) { return j ? j.length : 0; }
        var wj = function (a, b) { for (var c = o(a), d = Array(b), f = 0, g = 0, h = 0, j = 0; f < c; ++j) { var l = 1, n = 0, p; do p = a.charCodeAt(f++) - 63 - 1, l += p << n, n += 5; while (p >= 31); g += l & 1 ? ~(l >> 1) : l >> 1; l = 1; n = 0; do p = a.charCodeAt(f++) - 63 - 1, l += p << n, n += 5; while (p >= 31); h += l & 1 ? ~(l >> 1) : l >> 1; d[j] = [g * 1.0E-5, h * 1.0E-5]; } return d };
        var b = o(ls);
        return wj(pt, b);
    }
}
function ptAry2Map(ary) {
    var d = gc.map.createPointAry();
    for (var i in ary) {
        
        d.push(gc.map.createPoint(ary[i][1], ary[i][0]));
    }
    return d;
}