﻿var MMapPolygonCreator = function (m) {
    this.map = m;
    this.initmap = function () {
        //this.map = m;
        this.pts = this.map.createPointAry();
        this.mkary = [];
        this.pl = this.map.createPolyline(this.map.createPointAry());
        this.isOver = false;
        this.curmk = null;

        var ts = this;
        var cfn = function (e) {
            if (!ts.isOver) {
                if (ts.findmk(e)) return;

                ts.pts.push(ts.map.createPoint(e.eventX, e.eventY));

                var mk = ts.map.createMaker(ts.map.createPoint(e.eventX, e.eventY));
                ts.mkary.push(mk);
                ts.map.map.addEventListener(mk, MOUSE_CLICK, function (xe) {
                    ts.curmk = mk;
                    ts.draw(ts);
                });
                ts.draw(ts);
            } else {
                ts.map.map.removeEventListener(ts.map.map, MOUSE_CLICK, cfn);
                ts.clickevt = null;
            }
        }
        this.clickEfn = cfn;
        this.clickevt = this.map.map.addEventListener(this.map.map, MOUSE_CLICK, cfn);
    }
    this.findmk = function (pt) {
        if (this.mkary) {
            for (var i = 0; i < this.mkary.length; i++) {
                var t = this.mkary[i].lnglat;

                if (pt.eventX == t.lngX && pt.eventY == t.latY) {
                    return true;
                }
            }
        }
        return false;
    }
    this.draw = function (ts) {
        if (!ts) ts = this;
        if (ts.mkary.length > 1 && ts.mkary[0] == ts.curmk) {
            ts.isOver = true;
            ts.drawPolygon();
            ts.removePL();
            ts.removeMK();
            if (ts.clickEfn) {
                ts.map.map.removeEventListener(ts.map.map, MOUSE_CLICK, ts.clickEfn);
                ts.clickEfn = null;
            }
        } else {
            if (ts.pl) { ts.pl.setPath(ts.pts); }
        }
    }
    this.drawPolygon = function () {
        if (!this.pg) {
            this.pg = this.map.createPolygon(this.pts);
        } else {

        }
    }
    this.removePL = function () {
        if (this.pl) this.map.removeObj(this.pl);
        this.pl = null;
    }
    this.removeMK = function () {
        if (this.mkary)
            for (var i in this.mkary) {
                this.map.removeObj(this.mkary[i]);
            }
        this.mkary = null;
    }
    this.closedraw = function () {
        if (this.mkary)
            if (this.mkary.length > 1) {
                this.curmk = this.mkary[0];
                this.draw();
            }
    }
    this.removePg = function () {
        if (this.pg)
            this.map.removeObj(this.pg);
        this.pg = null;
    }
    this.removeAll = function () {
        this.removeMK();
        this.removePL();
        this.removePg();
        if (this.clickEfn) {
            this.map.map.removeEventListener(this.map.map, MOUSE_CLICK, this.clickEfn);
        }
    }
}
function MMapPolygonCreatorExt(o) {
    o.ext({
        createPolygonCreator: function () {
            var pc = new MMapPolygonCreator(o);
            pc.initmap();
            return pc;
        },
        getPolygonCreatorPath: function (pc) {
            return pc.pts;
        },
        removePolygonCreator: function (pc) {
            pc.removeAll();
        },
        closePolygonCreator: function (pc) {
            pc.closedraw();
        }
        ,
        polygonCreatorOver: function (pc) {
            return pc.isOver;
        }
    });
}