var MapabcProvider = function (mapid) {
    this.mapscripturl =
    this.maploadcb = null;
    this.map = null;
    PMap.call(this, mapid);
    var tthis = this;

    this.initmap = function (cb) {
        this.maploadcb = cb;

        //ѾǰأͽӼظӽű
        loadJS('js/mapabc/polygoncreator.js');
        if (typeof (MMapPolygonCreatorExt) == 'function') { MMapPolygonCreatorExt(this); }
        if (cb)
            cb();
    }
    this.create = function (id) {
        var mapoption = new MMapOptions();
        mapoption.zoom = 13; //õͼzoom
        mapoption.toolbar = DEFAULT; //ù
        mapoption.toolbarPos = new MPoint(20, 20);
        mapoption.overviewMap = SHOW; //ӥ
        mapoption.scale = SHOW;
        mapoption.fullscreenButton = SHOW;
        this.map = new MMap(id, mapoption);

        var ts = this;
        this.map.addEventListener(this.map, TIP_CLOSE, function (paa) {
            if (ts.closetipcb) ts.closetipcb();
            if (ts.marktipary) {
                for (var i = 0; i < ts.marktipary.length; i++) {
                    if (ts.marktipary[i]) ts.marktipary[i].opentip = false;
                }
                ts.marktipary = [];
            }
        });
        this.marktipary = [];
    }
    this.createPoint = function (lng, lat) {
        var pt = new MLngLat(lng, lat);
        pt.Lat = function () { return pt.latY; }
        pt.Lng = function () { return pt.lngX; }
        return pt;
    }
    this.createPointAry = function () {
        var t = new Array();
        t.forEach = function (cb) {
            if (cb && typeof (cb) == 'function') {
                for (var i = 0; i < this.length; i++) {
                    { cb(this[i], i); }
                }
            }
        }
        return t;
    }
    this.createSize = function (w, h) {
        return new MSize(w, h);
    }
    this.createMaker = function (pt, iconpath, size) {
        var opt = new MMarkerOptions();
        var m;
        if (iconpath) {
            opt.tipOption.tipPosition = new MPoint(0, -30);
            //opt.canShowTip = true;
            // opt.tipOption.content = 'testtesttest';
            opt.imageUrl = iconpath;
            m = new MMarker(pt, opt); //BMap.Marker(pt, (iconpath && size) ? { icon: new BMap.Icon(iconpath, size)} : null);
        } else {
            m = new MMarker(pt);
        }

        this.map.addOverlay(m);
        return m;
    }
    this.setMakerEvent = function (mk, t, cb) {
        switch (t) {
            case 'click':
                {
                    var ts = this;
                    if (cb)
                        this.map.addEventListener(mk, MOUSE_CLICK, function (pt) {
                            cb(ts.createPoint(pt.eventX, pt.eventY));
                        });
                }
                break;
        }
    }
    this.makerOptions = function (mk, o) {
        for (var i in o) {
            switch (i) {
                case 'drag':
                    mk.enableDragging(o[i]);
                    break;
            }
        }
    }
    this.setMakerIcon = function (mk, icon, pt) {
        mk.option.imageUrl = icon.imageUrl;
        mk.lnglat = pt;
        if (icon) icon.lnglat = pt;
        var bopen = mk.opentip;
        this.map.updateOverlay(mk);
        if (bopen) { this.openInfoWindow(mk, mk.option.tipOption.content); }

        //this.map.removeOverlay(mk);
        //this.map.addOverlay(mk);
    }
    this.makerCall = function (mk, n) {
        if (mk[n]) { return mk[n](); }
        else if (n == 'getPosition') {
            return mk.lnglat;
        }
    }
    this.createIcon = function (path, Size) {
        return { imageUrl: path, size: Size };
        var opt = new MGroundImageOptions();
        opt.imageUrl = path;
        var icon = new MGroundImage(this.getCenter(), opt);
        return icon;
    }
    this.updateIcon = function (icon, path) {
        icon.imageUrl = path;
        return;
        icon.option.imageUrl = (path);
        //this.map.removeOverlay(icon);
        //this.map.addOverlay(icon);
        this.map.updateOverlay(icon);
    }

    this.createLabel = function (str, pt, os) {
        var opt = new MLabelOptions();
        opt.content = str;
        opt.hasBorder = true;
        opt.backgroundColor = 0xffffff;
        opt.hasBackground = true;
        var l = new MLabel(pt, opt);
        this.map.addOverlay(l);
        return l;
    }
    this.updateLabel = function (l, pt, str) {
        l.lnglat = pt;
        l.option.content = str;
        if (l && pt) {
            this.map.removeOverlay(l);
            this.map.addOverlay(l); //ʹɾʾԶɾرգ鷳
            //    this.map.updateOverlay(l);
        }
    }
    this.createPolyline = function (pts, cb, ops) {
        //enableClicking,enableEditing
        var op = ops || { color: '#0f0', weight: 3, opacity: 1 };
        var opt = new MLineOptions();
        opt.lineStyle.thickness = 5;
        opt.lineStyle.color = 0xff0000; // op.color;
        opt.lineStyle.alpha = 0.7;
        opt.lineStyle.lineType = LINE_DASHED;

        var pl = new MPolyline(pts, opt); //{ strokeColor: op.color, strokeWeight: op.weight, strokeOpacity: op.opacity });
        this.map.addOverlay(pl);
        var os = this;
        if (cb)
            this.map.addEventListener(pl, MOUSE_CLICK,
            function (t, tg, pt, px) {
                cb(os.createPoint(t.eventX, t.eventY));
            });
        pl.setPath = function (pts) {
            pl.lnglatArr = pts;
            //os.map.removeOverlay(pl);
            //os.map.addOverlay(pl);
            os.map.updateOverlay(pl);
        }
        return pl;
    }
    this.openRuler = function (r) {
        this.map.setCurrentMouseTool(RULER);
        var ts = this;
        if (!this.rulerevt) {
            this.rulerRet = [];
            this.rulerevt =
            this.map.addEventListener(this.map, COMPUTE_AREA_END, function (param) {
                ts.rulerRet.push(param.overlayId);
            });
        }
    }
    this.createRuler = function () {
        var r = {}; // new BMapLib.DistanceTool(this.map);
        this.openRuler();
        return r;

    }
    this.closeRuler = function (r) {
        this.map.setCurrentMouseTool(PAN_WHEELZOOM);
        if (this.rulerRet) {
            for (var i = 0; i < this.rulerRet.length; i++) {
                this.map.removeOverlay(this.map.getOverlayById(this.rulerRet[i]));
            }
            this.rulerRet = [];
        }
    }
    this.createPolygon = function (pts, opts) {
        var op = { fcolor: '#f00', fopacity: 0.3, scolor: '#0ff', sopacity: 0.8, edit: false, click: false };
        for (var i in opts) { op[i] = opts[i]; }
        var mas = new MAreaStyle();
        mas.borderStyle.alpha = op.sopacity;
        mas.borderStyle.color = 0xff0000; // op.scolor;
        mas.fillStyle.alpha = op.fopacity;
        mas.fillStyle.color = 0x00ffff; // op.fcolor;
        mas.isEditable = op.edit;
        var ao = new MAreaOptions();
        ao.areaStyle = mas;
        ao.canShowTip = false;
        ao.isEditable = op.edit;
        var gn = new MPolygon(pts, ao);
        this.map.addOverlay(gn);
        return gn;
    }
    this.getPolygonPath = function (pg) {
        var pa = this.createPointAry();
        var p = pg.lnglatArr;
        for (var i = 0; i < p.length; i++) {
            pa.push(this.createPoint(p[i].lngX, p[i].latY));
        }
        return pa;
    }
    this.setPolygonPath = function (pg, path) {
        pg.lnglatArr = path;
    }
    this.panTo = function (pt) {
        this.map.panTo(pt);
    }
    this.centerAndZoom = function (pt, z) {
        this.map.setZoomAndCenter(z, pt);
    }
    this.getCenter = function () {
        var t = this.map.getCenter();
        return this.createPoint(t.lngX, t.latY);
    }

    this.setCenter = function (pt) { this.map.setCenter(pt); }
    this.getZoom = function () { return this.map.getZoomLevel(); }
    this.setZoom = function (z) { this.map.setZoomLevel(z); }
    this.zoomIn = function () { this.map.zoomIn(); }
    this.zoomOut = function () { this.map.zoomOut(); }
    this.removeObj = function (obj) {
        this.map.removeOverlay(obj);
    }
    this.removeAll = function () {
        this.map.removeAllOverlays();
    }
    this.clearPolygon = function () {
        this.removeAll();
    }
    this.pixelToPoint = function (px) { return this.map.fromContainerPixelToLngLat(px); }
    this.pointToPixel = function (pt) { return this.map.fromLngLatToContainerPixel(pt); }
    this.getGPSName = function (pt, cb) {
        {
            var mg = new MReGeoCodeSearch();
            var opt = new MReGeoCodeSearchOptions();
            mg.setCallbackFunction(
            function (data) {
                var ret = '';
                switch (data) {
                    case 'ok':
                        ret += "ʡ" + data.SpatialBean.Province.name + "<br />У" + data.SpatialBean.City.name + "<br />" + data.SpatialBean.District.name + "</span>";
                        break;
                    case 'error':
                        ret = 'getfailed';
                        break;
                    default:
                        ret = 'failed!';
                        break;
                }
                if (cb) { cb(ret); }
            }
            );
        }
    }
    this.closeInfoWindow = function (mk, info) {
        //mk.closeInfoWindow();
        //mk.option.canShowTip = false;
        if (mk) {
            mk.opentip = false;
        }
        this.map.closeTip();
        this.marktipary = [];
    }
    this.openInfoWindow = function (mk, html, cb) {
        //var iw = new BMap.InfoWindow(html);
        // mk.openInfoWindow(iw);
        //iw.addEventListener('close', function () {
        //     if (cb) cb();
        /// });
        //  return iw;
        if (mk) {
            mk.option.tipOption.content = html;
            mk.opentip = true;
            this.map.openTip(mk.lnglat, mk.option.tipOption);
        }
        this.closetipcb = cb;
        this.marktipary.push(mk);
    }

    //    //createploygon
    //    this.createPolygonCreator = function () {
    //        this.map.setCurrentMouseTool(DRAW_POLYGON);
    //    }
    //    this.getPolygonCreatorPath = function (p) {
    //        alert(this.map.getOverlaysByType(MOverlay.TYPE_ARE));
    //    }
    //    this.removePolygonCreator = function (o) {
    //        this.map.setCurrentMouseTool(PAN_WHEELZOOM);
    //    }
    //    this.closePolygonCreator = function (o) {
    //        this.map.setCurrentMouseTool(PAN_WHEELZOOM);
    //    }
    //    this.polygonCreatorOver = function (o) {
    //        return this.map.setCurrentMouseTool(DRAW_POLYGON).length == 1;
    //    }
}
MapabcProvider.prototype = new PMap;
